diff --git a/cpp/CMakeLists.txt b/cpp/CMakeLists.txt
index 6ab0200..e822ec5 100644
--- a/cpp/CMakeLists.txt
+++ b/cpp/CMakeLists.txt
@@ -1,126 +1,132 @@
-################################################################
-# CMakeLists.txt
-cmake_minimum_required(VERSION 3.8.2)
-project(OpenScenario-Cpp)
-message(STATUS "${PROJECT_NAME}")
-
-################################################################
-# Preprocessor settings
-option(SUPPORT_OSC_1_0 "Build the artifacts supporting OSC standard version 1.0" ON)
-option(SUPPORT_OSC_1_1 "Build the artifacts supporting OSC standard version 1.1" ON)
-option(SUPPORT_OSC_1_2 "Build the artifacts supporting OSC standard version 1.2" ON)
-
-if (SUPPORT_OSC_1_0)
-	add_definitions(-DSUPPORT_OSC_1_0)	
-endif (SUPPORT_OSC_1_0)
-if (SUPPORT_OSC_1_1)
-	add_definitions(-DSUPPORT_OSC_1_1)	
-endif (SUPPORT_OSC_1_1)
-if (SUPPORT_OSC_1_2)
-	add_definitions(-DSUPPORT_OSC_1_2)	
-endif (SUPPORT_OSC_1_2)
-
-
-
-################################################################
-# Write msbuild.exe for Windows build
-if(MSVC)
-    write_file("${CMAKE_CURRENT_SOURCE_DIR}/buildArtifact/msbuildcmd.txt" "cmd,${CMAKE_VS_MSBUILD_COMMAND}")
-endif(MSVC)
-
-
-################################################################
-# Add a module path for cmake modules
-list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}")
-include(CMakeHelpers)
-# Parallel build jobs
-# if(NOT MSVC)
-#     set(PARALLEL_BUILD_JOBS 8 CACHE STRING "Set amount of parallel build jobs")
-#     set(ENV{CMAKE_BUILD_PARALLEL_LEVEL} ${PARALLEL_BUILD_JOBS})
-# endif()
-# Set common, C++, and build params
-RAC_SET_COMMON_PARAM()
-RAC_SET_CPP_PARAM()
-RAC_SET_BUILD_PARAM()
-# Build static or shared libs
-option(BUILD_SHARED_LIBS "Build shared libraries" ON)
-
-
-################################################################
-# Add antlr features
-list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/buildAntlr4)
-
-if(${BUILD_SHARED_LIBS})
-    set(ANTLR4_WITH_STATIC_CRT OFF)
-else()
-    # required if linking to static library
-    add_definitions(-DANTLR4CPP_STATIC)
-    add_definitions(-DOSC_STATIC)
-    set(ANTLR4_WITH_STATIC_CRT ON)
-endif()
-
-set(ANTLR4_TAG 4.8)
-set(ANTLR4_ZIP_REPOSITORY ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/antlr/antlr4-${ANTLR4_TAG}.zip)
-set(ANTLR_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/antlr/antlr-${ANTLR4_TAG}-complete.jar)
-
-# add external build for antlrcpp
-include(ExternalAntlr4Cpp)
-# add antrl4cpp artifacts to project environment
-
-# add macros to generate ANTLR Cpp code from grammar
-find_package(ANTLR REQUIRED)
-
-
-################################################################
-# Build as Debug or Release, for Linux or Windows
-if(UNIX)
-    if(NOT CMAKE_BUILD_TYPE)
-        set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Debug, Release" FORCE)
-    endif(NOT CMAKE_BUILD_TYPE)
-    set(BUILD_TARGET_PARAM ${CMAKE_BUILD_TYPE})
-endif(UNIX)
-          
-if(NOT PLATFORM_PARAM)
-    set(PLATFORM_PARAM "${CMAKE_SYSTEM_NAME}" CACHE STRING "Linux, Windows, etc" FORCE)
-endif(NOT PLATFORM_PARAM)
-
-
-################################################################
-# Get company info
-RAC_GET_COMPANY_INFO("${PROJECT_SOURCE_DIR}/common/companyInfo.txt")
-# Get version
-RAC_GET_VERSION("common/version.h")
-message("Program version: ${VERSION_MAJOR}.${VERSION_MINOR}.${PATCHNUMBER}")
-message("OSC std version: ${OSC_VERSION_MAJOR}.${OSC_VERSION_MINOR}.${OSC_PATCHNUMBER}")
-set(FILE_VERSION_COMMA "${VERSION_MAJOR},${VERSION_MINOR},${PATCHNUMBER},0")
-set(FILE_VERSION_PERIOD "${VERSION_MAJOR}.${VERSION_MINOR}.${PATCHNUMBER}.0")
-set(OSC_VERSION_COMMA "${OSC_VERSION_MAJOR},${OSC_VERSION_MINOR},${OSC_PATCHNUMBER}")
-set(OSC_VERSION_PERIOD "${OSC_VERSION_MAJOR}.${OSC_VERSION_MINOR}.${OSC_PATCHNUMBER}")
- 
-
-################################################################
-# Add subprojects
-# Dependencies, not master
-set(MASTER_PROJECT FALSE)
-message(STATUS "Subprojects:")
-
-# Set compile output folder for OpenSCENARIO core libs
-# This is needed because of the way the makefiles for ANTLR4-Cpp-src are written
-unset(CMAKE_BUILD_TYPE CACHE)
-    
-# CoreLibraries
-add_subdirectory(openScenarioLib)
-add_subdirectory(expressionsLib)
-
-# Applications
-add_subdirectory(applications/openScenarioReader)
-add_subdirectory(applications/openScenarioTester)
-add_subdirectory(applications/indexerTester)
-add_subdirectory(applications/expressionsTester)
-
-
-################################################################
-# Visual Studio Startup Project and debug cmd line args
-if(MSVC)
-    set_property(DIRECTORY PROPERTY VS_STARTUP_PROJECT "OpenScenarioTester")
-endif()
+################################################################
+# CMakeLists.txt
+cmake_minimum_required(VERSION 3.8.2)
+project(OpenScenario-Cpp)
+message(STATUS "${PROJECT_NAME}")
+
+################################################################
+# Preprocessor settings
+option(SUPPORT_OSC_1_0 "Build the artifacts supporting OSC standard version 1.0" ON)
+option(SUPPORT_OSC_1_1 "Build the artifacts supporting OSC standard version 1.1" ON)
+option(SUPPORT_OSC_1_2 "Build the artifacts supporting OSC standard version 1.2" ON)
+
+if (SUPPORT_OSC_1_0)
+	add_definitions(-DSUPPORT_OSC_1_0)	
+endif (SUPPORT_OSC_1_0)
+if (SUPPORT_OSC_1_1)
+	add_definitions(-DSUPPORT_OSC_1_1)	
+endif (SUPPORT_OSC_1_1)
+if (SUPPORT_OSC_1_2)
+	add_definitions(-DSUPPORT_OSC_1_2)	
+endif (SUPPORT_OSC_1_2)
+
+
+
+################################################################
+# Write msbuild.exe for Windows build
+if(MSVC)
+    write_file("${CMAKE_CURRENT_SOURCE_DIR}/buildArtifact/msbuildcmd.txt" "cmd,${CMAKE_VS_MSBUILD_COMMAND}")
+endif(MSVC)
+
+################################################################
+# Allow for higher section count in object files in MinGW
+if(MINGW)
+  add_compile_options(-Wa,-mbig-obj -O2)
+endif()
+
+################################################################
+# Add a module path for cmake modules
+list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}")
+include(CMakeHelpers)
+# Parallel build jobs
+# if(NOT MSVC)
+#     set(PARALLEL_BUILD_JOBS 8 CACHE STRING "Set amount of parallel build jobs")
+#     set(ENV{CMAKE_BUILD_PARALLEL_LEVEL} ${PARALLEL_BUILD_JOBS})
+# endif()
+# Set common, C++, and build params
+RAC_SET_COMMON_PARAM()
+RAC_SET_CPP_PARAM()
+RAC_SET_BUILD_PARAM()
+# Build static or shared libs
+option(BUILD_SHARED_LIBS "Build shared libraries" ON)
+
+
+################################################################
+# Add antlr features
+list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/buildAntlr4)
+
+if(${BUILD_SHARED_LIBS})
+    set(ANTLR4_WITH_STATIC_CRT OFF)
+else()
+    # required if linking to static library
+    add_definitions(-DANTLR4CPP_STATIC)
+    add_definitions(-DOSC_STATIC)
+    set(ANTLR4_WITH_STATIC_CRT ON)
+endif()
+
+set(ANTLR4_TAG 4.8)
+set(ANTLR4_ZIP_REPOSITORY ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/antlr/antlr4-${ANTLR4_TAG}.zip)
+set(ANTLR4_MINGW_PATCH ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/antlr/antlr4-${ANTLR4_TAG}-mingw.patch)
+set(ANTLR_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/antlr/antlr-${ANTLR4_TAG}-complete.jar)
+
+# add external build for antlrcpp
+include(ExternalAntlr4Cpp)
+# add antrl4cpp artifacts to project environment
+
+# add macros to generate ANTLR Cpp code from grammar
+find_package(ANTLR REQUIRED)
+
+
+################################################################
+# Build as Debug or Release, for Linux or Windows
+if(UNIX)
+    if(NOT CMAKE_BUILD_TYPE)
+        set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Debug, Release" FORCE)
+    endif(NOT CMAKE_BUILD_TYPE)
+    set(BUILD_TARGET_PARAM ${CMAKE_BUILD_TYPE})
+endif(UNIX)
+          
+if(NOT PLATFORM_PARAM)
+    set(PLATFORM_PARAM "${CMAKE_SYSTEM_NAME}" CACHE STRING "Linux, Windows, etc" FORCE)
+endif(NOT PLATFORM_PARAM)
+
+
+################################################################
+# Get company info
+RAC_GET_COMPANY_INFO("${PROJECT_SOURCE_DIR}/common/companyInfo.txt")
+# Get version
+RAC_GET_VERSION("common/version.h")
+message("Program version: ${VERSION_MAJOR}.${VERSION_MINOR}.${PATCHNUMBER}")
+message("OSC std version: ${OSC_VERSION_MAJOR}.${OSC_VERSION_MINOR}.${OSC_PATCHNUMBER}")
+set(FILE_VERSION_COMMA "${VERSION_MAJOR},${VERSION_MINOR},${PATCHNUMBER},0")
+set(FILE_VERSION_PERIOD "${VERSION_MAJOR}.${VERSION_MINOR}.${PATCHNUMBER}.0")
+set(OSC_VERSION_COMMA "${OSC_VERSION_MAJOR},${OSC_VERSION_MINOR},${OSC_PATCHNUMBER}")
+set(OSC_VERSION_PERIOD "${OSC_VERSION_MAJOR}.${OSC_VERSION_MINOR}.${OSC_PATCHNUMBER}")
+ 
+
+################################################################
+# Add subprojects
+# Dependencies, not master
+set(MASTER_PROJECT FALSE)
+message(STATUS "Subprojects:")
+
+# Set compile output folder for OpenSCENARIO core libs
+# This is needed because of the way the makefiles for ANTLR4-Cpp-src are written
+unset(CMAKE_BUILD_TYPE CACHE)
+    
+# CoreLibraries
+add_subdirectory(openScenarioLib)
+add_subdirectory(expressionsLib)
+
+# Applications
+add_subdirectory(applications/openScenarioReader)
+add_subdirectory(applications/openScenarioTester)
+add_subdirectory(applications/indexerTester)
+add_subdirectory(applications/expressionsTester)
+
+
+################################################################
+# Visual Studio Startup Project and debug cmd line args
+if(MSVC)
+    set_property(DIRECTORY PROPERTY VS_STARTUP_PROJECT "OpenScenarioTester")
+endif()
diff --git a/cpp/CMakePresets.json b/cpp/CMakePresets.json
index 9a1933e..ea53a41 100644
--- a/cpp/CMakePresets.json
+++ b/cpp/CMakePresets.json
@@ -10,7 +10,7 @@
             "description": "Base preset for x64 architecture on Windows",
             "name": "x64Arch",
             "architecture": "x64",
-			"toolset": "host=x64",
+            "toolset": "host=x64",
             "environment": {
                 "PR_ENV_ARCH": "x64"
             },
@@ -450,6 +450,20 @@
                     "value": "TRUE"
                 }
             },
+            "warnings": { "dev": false },
+            "hidden": true
+        },
+        {
+            "name": "MSYS-Makefiles",
+            "description": "Base preset for MSYS Makefiles",
+            "generator": "MSYS Makefiles",
+            "binaryDir": "${sourceDir}/build/cg$env{PR_ENV_BUILD_TYPE}Make$env{PR_ENV_BINDING}",
+            "cacheVariables": {
+                "MASTER_PROJECT": {
+                    "type": "STRING",
+                    "value": "TRUE"
+                }
+            },
             "warnings": {"dev": false},
             "hidden": true
         },
@@ -502,6 +516,38 @@
             ],
             "hidden": true
         },
+        {
+            "name": "MSYS-shared",
+            "cacheVariables": {
+                "BUILD_SHARED_LIBS": {
+                    "type": "BOOL",
+                    "value": "ON"
+                }
+            },
+            "environment": {
+                "PR_ENV_BINDING": "Shared"
+            },
+            "inherits": [
+                "MSYS-Makefiles"
+            ],
+            "hidden": true
+        },
+        {
+            "name": "MSYS-static",
+            "cacheVariables": {
+                "BUILD_SHARED_LIBS": {
+                    "type": "BOOL",
+                    "value": "OFF"
+                }
+            },
+            "environment": {
+                "PR_ENV_BINDING": "Static"
+            },
+            "inherits": [
+                "MSYS-Makefiles"
+            ],
+            "hidden": true
+        },
         {
             "name": "Linux-static",
             "cacheVariables": {
@@ -576,6 +622,65 @@
                 "Build-type-relWithDebInfo"
             ],
             "hidden": true
+        },
+        {
+            "name": "MSYS-shared-debug",
+            "displayName": "MSYS shared debug",
+            "description": "Build using MSYS Makefiles",
+            "inherits": [
+                "MSYS-shared",
+                "Build-type-debug"
+            ]
+        },
+        {
+            "name": "MSYS-static-debug",
+            "displayName": "MSYS static debug",
+            "description": "Build using MSYS Makefiles",
+            "inherits": [
+                "MSYS-static",
+                "Build-type-debug"
+            ]
+        },
+        {
+            "name": "MSYS-shared-release",
+            "displayName": "MSYS shared release",
+            "description": "Build using MSYS Makefiles",
+            "inherits": [
+                "MSYS-shared",
+                "Build-type-release"
+            ]
+        },
+        {
+            "name": "MSYS-static-release",
+            "displayName": "MSYS static release",
+            "description": "Build using MSYS Makefiles",
+            "inherits": [
+                "MSYS-static",
+                "Build-type-release"
+            ]
+        },
+        {
+            "name": "MSYS-shared-relWithDebInfo",
+            "displayName": "MSYS shared relWithDebInfo",
+            "description": "Build using MSYS Makefiles",
+            "inherits": [
+                "MSYS-shared",
+                "Build-type-relWithDebInfo"
+            ],
+            "hidden": true
+        },
+        {
+            "name": "MSYS-static-relWithDebInfo",
+            "displayName": "MSYS static relWithDebInfo",
+            "description": "Build using MSYS Makefiles",
+            "environment": {
+                "PR_ENV_BUILD_TYPE": "RelWithDebInfo"
+            },
+            "inherits": [
+                "MSYS-static",
+                "Build-type-relWithDebInfo"
+            ],
+            "hidden": true
         }
     ],
     "buildPresets": [
@@ -617,6 +722,44 @@
             "configurePreset": "Linux-static-relWithDebInfo",
             "hidden": true
         },
+        {
+            "name": "Build-MSYS-shared-release",
+            "description": "Build shared release using MSYS Makefiles",
+            "displayName": "Build MSYS shared release",
+            "configurePreset": "MSYS-shared-release"
+        },
+        {
+            "name": "Build-MSYS-shared-debug",
+            "description": "Build shared debug using MSYS Makefiles",
+            "displayName": "Build MSYS shared debug",
+            "configurePreset": "MSYS-shared-debug"
+        },
+        {
+            "name": "Build-MSYS-shared-relWithDebInfo",
+            "description": "Build shared relWithDebInfo using MSYS Makefiles",
+            "displayName": "Build MSYS shared relWithDebInfo",
+            "configurePreset": "MSYS-shared-relWithDebInfo",
+            "hidden": true
+        },
+        {
+            "name": "Build-MSYS-static-release",
+            "description": "Build static release using MSYS Makefiles",
+            "displayName": "Build MSYS static release",
+            "configurePreset": "MSYS-static-release"
+        },
+        {
+            "name": "Build-MSYS-static-debug",
+            "description": "Build static debug using MSYS Makefiles",
+            "displayName": "Build MSYS static debug",
+            "configurePreset": "MSYS-static-debug"
+        },
+        {
+            "name": "Build-MSYS-static-relWithDebInfo",
+            "description": "Build static relWithDebInfo using MSYS Makefiles",
+            "displayName": "Build MSYS static relWithDebInfo",
+            "configurePreset": "MSYS-static-relWithDebInfo",
+            "hidden": true
+        },
         {
             "name": "Build-VS2022-x64-shared",
             "description": "Build shared 64 bit version using Visual Studio 2022",
@@ -797,3 +940,4 @@
         }
     ]
 }
+
diff --git a/cpp/applications/expressionsTester/src/test/OpenScenarioExpressionsTest.cpp b/cpp/applications/expressionsTester/src/test/OpenScenarioExpressionsTest.cpp
index 8cdf340..e3ee681 100644
--- a/cpp/applications/expressionsTester/src/test/OpenScenarioExpressionsTest.cpp
+++ b/cpp/applications/expressionsTester/src/test/OpenScenarioExpressionsTest.cpp
@@ -15,14 +15,14 @@
  * limitations under the License.
  */
 
-#ifdef WIN32
-#   include <direct.h>
-#   define GETCWD _getcwd
-#   define OS_PATH_MAX _MAX_PATH
-#elif defined (__linux__) || defined (__APPLE__)
+#if defined (__linux__) || defined (__APPLE__) || defined (__MINGW32__) || defined (__MINGW64__)
 #   include <unistd.h>
 #   define GETCWD getcwd
 #   define OS_PATH_MAX PATH_MAX
+#elif defined (WIN32)
+#   include <direct.h>
+#   define GETCWD _getcwd
+#   define OS_PATH_MAX _MAX_PATH
 #else
 #   error "Operating system not supported."
 #endif
diff --git a/cpp/applications/indexerTester/src/IndexerTester.cpp b/cpp/applications/indexerTester/src/IndexerTester.cpp
index 3d09e11..a84c7fb 100644
--- a/cpp/applications/indexerTester/src/IndexerTester.cpp
+++ b/cpp/applications/indexerTester/src/IndexerTester.cpp
@@ -1,96 +1,96 @@
-/*
- * Copyright 2020 RA Consulting
- *
- * RA Consulting GmbH licenses this file under the Apache License,
- * Version 2.0 (the "License"); you may not use this file except
- * in compliance with the License.
- * You may obtain a copy of the License at
- *
- *    http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifdef WIN32
-#   include <direct.h>
-#   define GETCWD _getcwd
-#   define OS_PATH_MAX _MAX_PATH
-#elif defined (__linux__) || defined (__APPLE__)
-#   include <unistd.h>
-#   define GETCWD getcwd
-#   define OS_PATH_MAX PATH_MAX
-#else
-#   error "Operating system not supported."
-#endif
-
-#include <iostream>
-#include "MemLeakDetection.h"
-#include "PositionIndex.h"
-#include "XMLLexer.h"
-#include "XMLParser.h"
-
-void Dump(PositionIndex& positionIndex, int& index)
-{
-    const auto kElementNode = positionIndex.GetElementNode(index);
-    std::cout << index << ": " << "(" << kElementNode->GetStartPosition().GetLine() << ", ";
-    std::cout << kElementNode->GetStartPosition().GetColumn() << ") - (" << kElementNode->GetEndPosition().GetLine();
-    std::cout << ", " << kElementNode->GetEndPosition().GetColumn() << ")" << std::endl;
-}
-
-void TestBooks()
-{
-    try 
-    {
-        char cwdBuffer[OS_PATH_MAX];
-		std::string filePath = "./test-rc/books.xml";
-		std::string currentPath = std::string(GETCWD(cwdBuffer, OS_PATH_MAX));
-        std::ifstream infile(filePath, std::ios::binary);
-        if (infile.bad() || infile.fail())
-        {
-            auto msg = "File " + filePath + " not found. Current Path: '" + currentPath + "'";
-            throw std::runtime_error(msg);
-        }
-
-        // read data as a block:
-        infile.seekg(0, infile.end);
-        const auto kLength = static_cast<unsigned int>(infile.tellg());
-        infile.seekg(0, infile.beg);
-        char * buffer = new char[kLength];
-        infile.read(buffer, kLength);
-        std::string fileData;
-        fileData.assign(buffer, kLength);
-        delete[] buffer;
-        infile.close();
-
-        antlr4::ANTLRInputStream input(fileData);
-        XMLLexer lexer(&input);
-        antlr4::CommonTokenStream tokens(&lexer);
-        XMLParser parser(&tokens);
-        parser.document();
-
-        auto positionIndex = parser.GetPositionIndex();
-        for (int i = 0; i < positionIndex.GetSize(); i++)
-        {
-            Dump(positionIndex, i);
-        }
-
-    }
-    catch (std::runtime_error & e)
-    {
-        std::cout << e.what();
-    }
-}
-
-int main(int argc, char** argv)
-{
-#if defined(_DEBUG) && defined(WIN32)
-    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
-#endif
-
-    TestBooks();
-
-}
+/*
+ * Copyright 2020 RA Consulting
+ *
+ * RA Consulting GmbH licenses this file under the Apache License,
+ * Version 2.0 (the "License"); you may not use this file except
+ * in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#if defined (__linux__) || defined (__APPLE__) || defined (__MINGW32__) || defined (__MINGW64__)
+#   include <unistd.h>
+#   define GETCWD getcwd
+#   define OS_PATH_MAX PATH_MAX
+#elif defined (WIN32)
+#   include <direct.h>
+#   define GETCWD _getcwd
+#   define OS_PATH_MAX _MAX_PATH
+#else
+#   error "Operating system not supported."
+#endif
+
+#include <iostream>
+#include "MemLeakDetection.h"
+#include "PositionIndex.h"
+#include "XMLLexer.h"
+#include "XMLParser.h"
+
+void Dump(PositionIndex& positionIndex, int& index)
+{
+    const auto kElementNode = positionIndex.GetElementNode(index);
+    std::cout << index << ": " << "(" << kElementNode->GetStartPosition().GetLine() << ", ";
+    std::cout << kElementNode->GetStartPosition().GetColumn() << ") - (" << kElementNode->GetEndPosition().GetLine();
+    std::cout << ", " << kElementNode->GetEndPosition().GetColumn() << ")" << std::endl;
+}
+
+void TestBooks()
+{
+    try 
+    {
+        char cwdBuffer[OS_PATH_MAX];
+		std::string filePath = "./test-rc/books.xml";
+		std::string currentPath = std::string(GETCWD(cwdBuffer, OS_PATH_MAX));
+        std::ifstream infile(filePath, std::ios::binary);
+        if (infile.bad() || infile.fail())
+        {
+            auto msg = "File " + filePath + " not found. Current Path: '" + currentPath + "'";
+            throw std::runtime_error(msg);
+        }
+
+        // read data as a block:
+        infile.seekg(0, infile.end);
+        const auto kLength = static_cast<unsigned int>(infile.tellg());
+        infile.seekg(0, infile.beg);
+        char * buffer = new char[kLength];
+        infile.read(buffer, kLength);
+        std::string fileData;
+        fileData.assign(buffer, kLength);
+        delete[] buffer;
+        infile.close();
+
+        antlr4::ANTLRInputStream input(fileData);
+        XMLLexer lexer(&input);
+        antlr4::CommonTokenStream tokens(&lexer);
+        XMLParser parser(&tokens);
+        parser.document();
+
+        auto positionIndex = parser.GetPositionIndex();
+        for (int i = 0; i < positionIndex.GetSize(); i++)
+        {
+            Dump(positionIndex, i);
+        }
+
+    }
+    catch (std::runtime_error & e)
+    {
+        std::cout << e.what();
+    }
+}
+
+int main(int argc, char** argv)
+{
+#if defined(_DEBUG) && defined(WIN32)
+    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
+#endif
+
+    TestBooks();
+
+}
diff --git a/cpp/applications/openScenarioReader/src/OpenScenarioReader.cpp b/cpp/applications/openScenarioReader/src/OpenScenarioReader.cpp
index d29c552..8f9ce49 100644
--- a/cpp/applications/openScenarioReader/src/OpenScenarioReader.cpp
+++ b/cpp/applications/openScenarioReader/src/OpenScenarioReader.cpp
@@ -171,7 +171,7 @@ int CheckFile(std::string& inputFileName, std::string& paramFileName, std::strin
                 return ERROR_RESULT;
             }
 
-            std::ifstream paramFile(wparamFileName);
+            std::ifstream paramFile(wparamFileName.c_str());
 #elif defined (__linux__) || defined (__APPLE__)
             std::ifstream paramFile(paramFileName);
 #else
@@ -247,7 +247,7 @@ int CheckFile(std::string& inputFileName, std::string& paramFileName, std::strin
         auto msg = "Conversion from utf8 string to wstring failed: " + inputFileName;
         return ERROR_RESULT;
     }
-    std::ifstream inputFile(winputFileName);
+    std::ifstream inputFile(winputFileName.c_str());
 
 #elif defined (__linux__) || defined (__APPLE__)
     std::ifstream inputFile(inputFileName);
@@ -339,7 +339,7 @@ int CheckFile(std::string& inputFileName, std::string& paramFileName, std::strin
     return result;
 }
 
-#ifdef WIN32
+#if defined (WIN32) && !defined (__MINGW32__) && !defined (__MINGW64__)
 int wmain(int argc, wchar_t** argv)
 {
     SetConsoleOutputCP(CP_UTF8);
@@ -458,7 +458,7 @@ int wmain(int argc, wchar_t** argv)
 
     return result;
 }
-#elif defined (__linux__) || defined (__APPLE__)
+#elif defined (__linux__) || defined (__APPLE__) || defined (__MINGW32__) || defined (__MINGW64__)
 int main(int argc, char** argv)
 {
     std::stringstream versionStream;
diff --git a/cpp/applications/openScenarioTester/src/TestBaseV1_0.cpp b/cpp/applications/openScenarioTester/src/TestBaseV1_0.cpp
index 28e5a36..527fd49 100644
--- a/cpp/applications/openScenarioTester/src/TestBaseV1_0.cpp
+++ b/cpp/applications/openScenarioTester/src/TestBaseV1_0.cpp
@@ -105,8 +105,7 @@ namespace NET_ASAM_OPENSCENARIO
             {
                 return "";
             }
-            std::ifstream file(path);
-
+            std::ifstream file(path.c_str());
 #elif defined (__linux__) || defined (__APPLE__)
             std::ifstream file(_executablePath + "/" + kInputDir + fileName);
 #else
diff --git a/cpp/applications/openScenarioTester/src/TestBaseV1_1.cpp b/cpp/applications/openScenarioTester/src/TestBaseV1_1.cpp
index 5f24da2..81f686f 100644
--- a/cpp/applications/openScenarioTester/src/TestBaseV1_1.cpp
+++ b/cpp/applications/openScenarioTester/src/TestBaseV1_1.cpp
@@ -123,8 +123,7 @@ namespace NET_ASAM_OPENSCENARIO
             {
                 return "";
             }
-            std::ifstream file(path);
-
+            std::ifstream file(path.c_str());
 #elif defined (__linux__) || defined (__APPLE__)
             std::ifstream file( _executablePath + "/" + kInputDir + fileName);
 #else
diff --git a/cpp/applications/openScenarioTester/src/TestBaseV1_2.cpp b/cpp/applications/openScenarioTester/src/TestBaseV1_2.cpp
index 2cd2615..b7277dd 100644
--- a/cpp/applications/openScenarioTester/src/TestBaseV1_2.cpp
+++ b/cpp/applications/openScenarioTester/src/TestBaseV1_2.cpp
@@ -123,7 +123,7 @@ namespace NET_ASAM_OPENSCENARIO
             {
                 return "";
             }
-            std::ifstream file(path);
+            std::ifstream file(path.c_str());
 
 #elif defined (__linux__) || defined (__APPLE__)
             std::ifstream file( _executablePath + "/" + kInputDir + fileName);
diff --git a/cpp/applications/openScenarioTester/src/TestReaderV1_0.cpp b/cpp/applications/openScenarioTester/src/TestReaderV1_0.cpp
index d2359de..c7cb8ad 100644
--- a/cpp/applications/openScenarioTester/src/TestReaderV1_0.cpp
+++ b/cpp/applications/openScenarioTester/src/TestReaderV1_0.cpp
@@ -35,7 +35,9 @@ namespace NET_ASAM_OPENSCENARIO
 		
 		int TestReader::ExecuteSystemCommand( std::string& command )
 		{
-	#ifdef WIN32
+	#if defined (__MINGW32__) || defined (__MINGW64__)
+			return system(command.c_str());
+	#elif defined (WIN32)
 			std::wstring wstringCommand;
 			if (!FileResourceLocator::Utf8ToWstring(command, wstringCommand)) { return -1; }
 			return _wsystem(wstringCommand.c_str());
diff --git a/cpp/applications/openScenarioTester/src/TestReaderV1_1.cpp b/cpp/applications/openScenarioTester/src/TestReaderV1_1.cpp
index aeb1d0e..3f859cf 100644
--- a/cpp/applications/openScenarioTester/src/TestReaderV1_1.cpp
+++ b/cpp/applications/openScenarioTester/src/TestReaderV1_1.cpp
@@ -34,7 +34,9 @@ namespace NET_ASAM_OPENSCENARIO
 		
 		int TestReader::ExecuteSystemCommand( std::string& command )
 		{
-	#ifdef WIN32
+	#if defined (__MINGW32__) || defined (__MINGW64__)
+			return system(command.c_str());
+	#elif defined (WIN32)
 			std::wstring wstringCommand;
 			if (!FileResourceLocator::Utf8ToWstring(command, wstringCommand)) { return -1; }
 			return _wsystem(wstringCommand.c_str() );
diff --git a/cpp/applications/openScenarioTester/src/TestReaderV1_2.cpp b/cpp/applications/openScenarioTester/src/TestReaderV1_2.cpp
index 768fade..670279d 100644
--- a/cpp/applications/openScenarioTester/src/TestReaderV1_2.cpp
+++ b/cpp/applications/openScenarioTester/src/TestReaderV1_2.cpp
@@ -37,7 +37,9 @@ namespace NET_ASAM_OPENSCENARIO
 		
 		int TestReader::ExecuteSystemCommand( std::string& command )
 		{
-	#ifdef WIN32
+	#if defined (__MINGW32__) || defined (__MINGW64__)
+			return system(command.c_str());
+	#elif defined (WIN32)
 			std::wstring wstringCommand;
 			if (!FileResourceLocator::Utf8ToWstring(command, wstringCommand)) { return -1; }
 			return _wsystem(wstringCommand.c_str() );
diff --git a/cpp/applications/openScenarioTester/src/TestVersionOptionsWithReader.cpp b/cpp/applications/openScenarioTester/src/TestVersionOptionsWithReader.cpp
index 4bf1b8e..df6c507 100644
--- a/cpp/applications/openScenarioTester/src/TestVersionOptionsWithReader.cpp
+++ b/cpp/applications/openScenarioTester/src/TestVersionOptionsWithReader.cpp
@@ -1,121 +1,121 @@
-/*
- * Copyright 2020 RA Consulting
- *
- * RA Consulting GmbH licenses this file under the Apache License,
- * Version 2.0 (the "License"); you may not use this file except
- * in compliance with the License.
- * You may obtain a copy of the License at
- *
- *    http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#include "TestVersionOptionsWithReader.h"
-
-#include <iostream>
-
-#include "FileResourceLocator.h"
-
-#define ASSERT_LOCATION __FILE__, __func__, __LINE__
-#ifdef WIN32
-#   define DOT_SLASH ""
-#elif defined (__linux__) || defined (__APPLE__)
-#   include <sys/wait.h>
-#   define DOT_SLASH "./"
-#else
-#   error "Operating system not supported."
-#endif
-
-namespace NET_ASAM_OPENSCENARIO
-{		
-	TestVersionOptionsWithReader::TestVersionOptionsWithReader(std::string& executablePath) : _executablePath(executablePath) {}
-
-	int TestVersionOptionsWithReader::ExecuteSystemCommand(std::string& command)
-	{
-#ifdef WIN32
-		std::wstring wstringCommand;
-		if (!FileResourceLocator::Utf8ToWstring(command, wstringCommand)) { return -1; }
-		return _wsystem(wstringCommand.c_str());
-#elif defined (__linux__) || defined (__APPLE__)
-		auto ret = system(command.c_str());
-		return WEXITSTATUS(ret);
-#else
-#   error "Operating system not supported."
-#endif
-	}
-
-	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_0() const
-	{
-		return TestOptionNotSetVersion("1_0", "Standard Version 1.0 is not supported. Compile Reader with SUPPORT_OSC_1_0 option.");
-	}
-
-	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_1() const
-	{
-		return TestOptionNotSetVersion("1_1", "Standard Version 1.1 is not supported. Compile Reader with SUPPORT_OSC_1_1 option.");
-	}
-	
-	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_2() const
-	{
-		return TestOptionNotSetVersion("1_2", "Standard Version 1.2 is not supported. Compile Reader with SUPPORT_OSC_1_2 option.");
-	}
-
-	bool TestVersionOptionsWithReader::TestOptionNotSetVersion(std::string version, std::string errorMessage) const
-	{
-		std::string command(DOT_SLASH); command.append("OpenScenarioReader");
-		command += " -i " + _executablePath + "/" + kInputDir + "simpleImport/simpleImport.xosc";
-		command += " -v"+version+" ";
-		command += " > " + _executablePath + "/" + kInputDir + kResultFileName;
-		auto res = Assert(ERROR_RESULT == ExecuteSystemCommand(command), ASSERT_LOCATION);
-		res = res && Assert(errorMessage == GetLine(kResultFileName, 5), ASSERT_LOCATION);
-		return res;
-	}
-
-	bool TestVersionOptionsWithReader::Assert(const bool condition, const std::string fileName, const std::string function, const int lineNumber)
-	{
-		if (!condition)
-			std::cout << "Assert failed in file " << fileName << " at line " << lineNumber << " " << function << std::endl;
-		return condition;
-	}
-
-	std::string TestVersionOptionsWithReader::GetLine(const std::string fileName, const int lineNum) const
-	{
-#ifdef WIN32
-		std::wstring path;
-		if (!FileResourceLocator::Utf8ToWstring(_executablePath + "/" + kInputDir + fileName, path))
-		{
-			return "";
-		}
-		std::ifstream file(path);
-
-#elif defined (__linux__) || defined (__APPLE__)
-		std::ifstream file(_executablePath + "/" + kInputDir + fileName);
-#else
-#   error "Operating system not supported."
-#endif
-		std::string line;
-
-		if (file.bad() || file.fail())
-		{
-			return "";
-		}
-
-		int counter = 0;
-
-		while (std::getline(file, line))
-		{
-			counter++;
-			if (counter == lineNum)
-			{
-				file.close();
-				return line;
-			}
-		}
-		file.close();
-		return "";
-	}
-}
+/*
+ * Copyright 2020 RA Consulting
+ *
+ * RA Consulting GmbH licenses this file under the Apache License,
+ * Version 2.0 (the "License"); you may not use this file except
+ * in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include "TestVersionOptionsWithReader.h"
+
+#include <iostream>
+
+#include "FileResourceLocator.h"
+
+#define ASSERT_LOCATION __FILE__, __func__, __LINE__
+#ifdef WIN32
+#   define DOT_SLASH ""
+#elif defined (__linux__) || defined (__APPLE__)
+#   include <sys/wait.h>
+#   define DOT_SLASH "./"
+#else
+#   error "Operating system not supported."
+#endif
+
+namespace NET_ASAM_OPENSCENARIO
+{		
+	TestVersionOptionsWithReader::TestVersionOptionsWithReader(std::string& executablePath) : _executablePath(executablePath) {}
+
+	int TestVersionOptionsWithReader::ExecuteSystemCommand(std::string& command)
+	{
+#ifdef WIN32
+		std::wstring wstringCommand;
+		if (!FileResourceLocator::Utf8ToWstring(command, wstringCommand)) { return -1; }
+		return _wsystem(wstringCommand.c_str());
+#elif defined (__linux__) || defined (__APPLE__)
+		auto ret = system(command.c_str());
+		return WEXITSTATUS(ret);
+#else
+#   error "Operating system not supported."
+#endif
+	}
+
+	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_0() const
+	{
+		return TestOptionNotSetVersion("1_0", "Standard Version 1.0 is not supported. Compile Reader with SUPPORT_OSC_1_0 option.");
+	}
+
+	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_1() const
+	{
+		return TestOptionNotSetVersion("1_1", "Standard Version 1.1 is not supported. Compile Reader with SUPPORT_OSC_1_1 option.");
+	}
+	
+	bool TestVersionOptionsWithReader::TestOptionNotSetVersion1_2() const
+	{
+		return TestOptionNotSetVersion("1_2", "Standard Version 1.2 is not supported. Compile Reader with SUPPORT_OSC_1_2 option.");
+	}
+
+	bool TestVersionOptionsWithReader::TestOptionNotSetVersion(std::string version, std::string errorMessage) const
+	{
+		std::string command(DOT_SLASH); command.append("OpenScenarioReader");
+		command += " -i " + _executablePath + "/" + kInputDir + "simpleImport/simpleImport.xosc";
+		command += " -v"+version+" ";
+		command += " > " + _executablePath + "/" + kInputDir + kResultFileName;
+		auto res = Assert(ERROR_RESULT == ExecuteSystemCommand(command), ASSERT_LOCATION);
+		res = res && Assert(errorMessage == GetLine(kResultFileName, 5), ASSERT_LOCATION);
+		return res;
+	}
+
+	bool TestVersionOptionsWithReader::Assert(const bool condition, const std::string fileName, const std::string function, const int lineNumber)
+	{
+		if (!condition)
+			std::cout << "Assert failed in file " << fileName << " at line " << lineNumber << " " << function << std::endl;
+		return condition;
+	}
+
+	std::string TestVersionOptionsWithReader::GetLine(const std::string fileName, const int lineNum) const
+	{
+#ifdef WIN32
+		std::wstring path;
+		if (!FileResourceLocator::Utf8ToWstring(_executablePath + "/" + kInputDir + fileName, path))
+		{
+			return "";
+		}
+		std::ifstream file(path.c_str());
+
+#elif defined (__linux__) || defined (__APPLE__)
+		std::ifstream file(_executablePath + "/" + kInputDir + fileName);
+#else
+#   error "Operating system not supported."
+#endif
+		std::string line;
+
+		if (file.bad() || file.fail())
+		{
+			return "";
+		}
+
+		int counter = 0;
+
+		while (std::getline(file, line))
+		{
+			counter++;
+			if (counter == lineNum)
+			{
+				file.close();
+				return line;
+			}
+		}
+		file.close();
+		return "";
+	}
+}
diff --git a/cpp/buildAntlr4/ExternalAntlr4Cpp.cmake b/cpp/buildAntlr4/ExternalAntlr4Cpp.cmake
index a59385d..74f1044 100644
--- a/cpp/buildAntlr4/ExternalAntlr4Cpp.cmake
+++ b/cpp/buildAntlr4/ExternalAntlr4Cpp.cmake
@@ -84,6 +84,7 @@ if(ANTLR4_ZIP_REPOSITORY)
       PREFIX antlr4_runtime
       URL ${ANTLR4_ZIP_REPOSITORY}
       DOWNLOAD_DIR ${CMAKE_CURRENT_BINARY_DIR}
+      PATCH_COMMAND "/usr/bin/patch" "-p1" "<" "${ANTLR4_MINGW_PATCH}"
       BUILD_COMMAND ""
       BUILD_IN_SOURCE 1
       SOURCE_DIR ${ANTLR4_ROOT}
diff --git a/cpp/expressionsLib/inc/ExprType.h b/cpp/expressionsLib/inc/ExprType.h
index 29842fd..ddec180 100644
--- a/cpp/expressionsLib/inc/ExprType.h
+++ b/cpp/expressionsLib/inc/ExprType.h
@@ -157,7 +157,7 @@ namespace OscExpression
 	public:
 
 		// No default constructor
-		OSC_EXPR_EXP ExprType() = delete;
+		ExprType() = delete;
 
 		/**
 		 * Retrieves the literal from this object.
diff --git a/cpp/expressionsLib/inc/SemanticException.h b/cpp/expressionsLib/inc/SemanticException.h
index 9a450b6..a920a8a 100644
--- a/cpp/expressionsLib/inc/SemanticException.h
+++ b/cpp/expressionsLib/inc/SemanticException.h
@@ -33,7 +33,7 @@ namespace OscExpression
 		size_t column;
 	public:
 		// delete Default Constructor
-		OSC_EXPR_EXP SemanticException() = delete;
+		SemanticException() = delete;
 
 
 		/**
diff --git a/cpp/openScenarioLib/generated/v1_0/api/ApiClassInterfacesV1_0.h b/cpp/openScenarioLib/generated/v1_0/api/ApiClassInterfacesV1_0.h
index 9c55a2b..99dd22a 100644
--- a/cpp/openScenarioLib/generated/v1_0/api/ApiClassInterfacesV1_0.h
+++ b/cpp/openScenarioLib/generated/v1_0/api/ApiClassInterfacesV1_0.h
@@ -24,6 +24,16 @@
 #include "OscInterfacesV1_0.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_0
@@ -8400,3 +8410,13 @@ namespace NET_ASAM_OPENSCENARIO
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_0/api/EnumerationsV1_0.h b/cpp/openScenarioLib/generated/v1_0/api/EnumerationsV1_0.h
index 56b46fa..f456356 100644
--- a/cpp/openScenarioLib/generated/v1_0/api/EnumerationsV1_0.h
+++ b/cpp/openScenarioLib/generated/v1_0/api/EnumerationsV1_0.h
@@ -23,6 +23,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_0
@@ -1662,3 +1672,13 @@ namespace NET_ASAM_OPENSCENARIO
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_0/checker/impl/ScenarioCheckerImplV1_0.h b/cpp/openScenarioLib/generated/v1_0/checker/impl/ScenarioCheckerImplV1_0.h
index 499b54e..5d9df76 100644
--- a/cpp/openScenarioLib/generated/v1_0/checker/impl/ScenarioCheckerImplV1_0.h
+++ b/cpp/openScenarioLib/generated/v1_0/checker/impl/ScenarioCheckerImplV1_0.h
@@ -39,7 +39,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
diff --git a/cpp/openScenarioLib/generated/v1_0/impl/ApiClassImplV1_0.h b/cpp/openScenarioLib/generated/v1_0/impl/ApiClassImplV1_0.h
index 8d6a3c0..a1fd7e4 100644
--- a/cpp/openScenarioLib/generated/v1_0/impl/ApiClassImplV1_0.h
+++ b/cpp/openScenarioLib/generated/v1_0/impl/ApiClassImplV1_0.h
@@ -31,6 +31,16 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_0
@@ -18548,3 +18558,13 @@ namespace NET_ASAM_OPENSCENARIO
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_0/impl/OpenScenarioWriterFactoryImplV1_0.h b/cpp/openScenarioLib/generated/v1_0/impl/OpenScenarioWriterFactoryImplV1_0.h
index 7ccea8a..5b9c398 100644
--- a/cpp/openScenarioLib/generated/v1_0/impl/OpenScenarioWriterFactoryImplV1_0.h
+++ b/cpp/openScenarioLib/generated/v1_0/impl/OpenScenarioWriterFactoryImplV1_0.h
@@ -31,7 +31,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
+        class OPENSCENARIOLIB_EXP OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
         {
         public:
 
diff --git a/cpp/openScenarioLib/generated/v1_1/api/ApiClassInterfacesV1_1.h b/cpp/openScenarioLib/generated/v1_1/api/ApiClassInterfacesV1_1.h
index 03d95ca..78ea6e1 100644
--- a/cpp/openScenarioLib/generated/v1_1/api/ApiClassInterfacesV1_1.h
+++ b/cpp/openScenarioLib/generated/v1_1/api/ApiClassInterfacesV1_1.h
@@ -24,6 +24,16 @@
 #include "OscInterfacesV1_1.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_1
@@ -15770,3 +15780,13 @@ Multiple constraint groups are
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_1/api/EnumerationsV1_1.h b/cpp/openScenarioLib/generated/v1_1/api/EnumerationsV1_1.h
index 8e7aa15..c06e1a0 100644
--- a/cpp/openScenarioLib/generated/v1_1/api/EnumerationsV1_1.h
+++ b/cpp/openScenarioLib/generated/v1_1/api/EnumerationsV1_1.h
@@ -23,6 +23,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_1
@@ -2058,3 +2068,13 @@ Smallest lateral distance (y for cartesian coordinate systems, t for road-based
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_1/checker/impl/ScenarioCheckerImplV1_1.h b/cpp/openScenarioLib/generated/v1_1/checker/impl/ScenarioCheckerImplV1_1.h
index 15435ad..0e64ef8 100644
--- a/cpp/openScenarioLib/generated/v1_1/checker/impl/ScenarioCheckerImplV1_1.h
+++ b/cpp/openScenarioLib/generated/v1_1/checker/impl/ScenarioCheckerImplV1_1.h
@@ -39,7 +39,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
diff --git a/cpp/openScenarioLib/generated/v1_1/impl/ApiClassImplV1_1.h b/cpp/openScenarioLib/generated/v1_1/impl/ApiClassImplV1_1.h
index 5d5609a..ff76f7c 100644
--- a/cpp/openScenarioLib/generated/v1_1/impl/ApiClassImplV1_1.h
+++ b/cpp/openScenarioLib/generated/v1_1/impl/ApiClassImplV1_1.h
@@ -31,6 +31,16 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_1
@@ -24338,3 +24348,13 @@ namespace NET_ASAM_OPENSCENARIO
     }
 }
 
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_1/impl/OpenScenarioWriterFactoryImplV1_1.h b/cpp/openScenarioLib/generated/v1_1/impl/OpenScenarioWriterFactoryImplV1_1.h
index 907f46f..b1eac4d 100644
--- a/cpp/openScenarioLib/generated/v1_1/impl/OpenScenarioWriterFactoryImplV1_1.h
+++ b/cpp/openScenarioLib/generated/v1_1/impl/OpenScenarioWriterFactoryImplV1_1.h
@@ -31,7 +31,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
+        class OPENSCENARIOLIB_EXP OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
         {
         public:
 
diff --git a/cpp/openScenarioLib/generated/v1_2/api/ApiClassInterfacesV1_2.h b/cpp/openScenarioLib/generated/v1_2/api/ApiClassInterfacesV1_2.h
index 8306f87..62e932e 100644
--- a/cpp/openScenarioLib/generated/v1_2/api/ApiClassInterfacesV1_2.h
+++ b/cpp/openScenarioLib/generated/v1_2/api/ApiClassInterfacesV1_2.h
@@ -24,6 +24,21 @@
 #include "OscInterfacesV1_2.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
+#if defined(GetFreeSpace) || defined(GetFreeSpace)
+#   pragma push_macro("GetFreeSpace")
+#   undef GetFreeSpace
+#endif // __MINGW64__ or __MINGW32__
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_2
@@ -19236,3 +19251,17 @@ Multiple constraint groups are
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
+
+#if defined(GetFreeSpace) || defined(GetFreeSpace)
+#   pragma pop_macro("GetFreeSpace")
+#endif // __MINGW64__ or __MINGW32__
\ No newline at end of file
diff --git a/cpp/openScenarioLib/generated/v1_2/api/EnumerationsV1_2.h b/cpp/openScenarioLib/generated/v1_2/api/EnumerationsV1_2.h
index c9578bc..6f7700d 100644
--- a/cpp/openScenarioLib/generated/v1_2/api/EnumerationsV1_2.h
+++ b/cpp/openScenarioLib/generated/v1_2/api/EnumerationsV1_2.h
@@ -23,6 +23,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_2
@@ -3345,3 +3355,13 @@ Smallest lateral distance (y for cartesian coordinate systems, t for road-based
 
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/cpp/openScenarioLib/generated/v1_2/checker/impl/ScenarioCheckerImplV1_2.h b/cpp/openScenarioLib/generated/v1_2/checker/impl/ScenarioCheckerImplV1_2.h
index c09a0f6..62de493 100644
--- a/cpp/openScenarioLib/generated/v1_2/checker/impl/ScenarioCheckerImplV1_2.h
+++ b/cpp/openScenarioLib/generated/v1_2/checker/impl/ScenarioCheckerImplV1_2.h
@@ -39,7 +39,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
diff --git a/cpp/openScenarioLib/generated/v1_2/impl/ApiClassImplV1_2.h b/cpp/openScenarioLib/generated/v1_2/impl/ApiClassImplV1_2.h
index 36a7954..7e981d7 100644
--- a/cpp/openScenarioLib/generated/v1_2/impl/ApiClassImplV1_2.h
+++ b/cpp/openScenarioLib/generated/v1_2/impl/ApiClassImplV1_2.h
@@ -31,6 +31,22 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
+#if defined(GetFreeSpace) || defined(GetFreeSpace)
+#   pragma push_macro("GetFreeSpace")
+#   undef GetFreeSpace
+#endif // __MINGW64__ or __MINGW32__
+
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace v1_2
@@ -28971,3 +28987,17 @@ namespace NET_ASAM_OPENSCENARIO
     }
 }
 
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
+
+#if defined(GetFreeSpace) || defined(GetFreeSpace)
+#   pragma pop_macro("GetFreeSpace")
+#endif // __MINGW64__ or __MINGW32__
diff --git a/cpp/openScenarioLib/generated/v1_2/impl/OpenScenarioWriterFactoryImplV1_2.h b/cpp/openScenarioLib/generated/v1_2/impl/OpenScenarioWriterFactoryImplV1_2.h
index b04b560..9d579d0 100644
--- a/cpp/openScenarioLib/generated/v1_2/impl/OpenScenarioWriterFactoryImplV1_2.h
+++ b/cpp/openScenarioLib/generated/v1_2/impl/OpenScenarioWriterFactoryImplV1_2.h
@@ -31,7 +31,7 @@ namespace NET_ASAM_OPENSCENARIO
          * 
          * @author RA Consulting OpenSCENARIO generation facility
         */
-        class OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
+        class OPENSCENARIOLIB_EXP OpenScenarioWriterFactoryImpl: public IOpenScenarioWriterFactory  
         {
         public:
 
diff --git a/cpp/openScenarioLib/src/common/ContentMessage.cpp b/cpp/openScenarioLib/src/common/ContentMessage.cpp
index 7ab5d65..c041979 100644
--- a/cpp/openScenarioLib/src/common/ContentMessage.cpp
+++ b/cpp/openScenarioLib/src/common/ContentMessage.cpp
@@ -27,6 +27,8 @@ namespace NET_ASAM_OPENSCENARIO
 {
     ContentMessage::ContentMessage(const std::string message, const ErrorLevel errorLevel): _message(message), _errorLevel(errorLevel) {}
 
+    ContentMessage::~ContentMessage() {}
+
     std::string ContentMessage::GetMsg()
     {
         return _message;
diff --git a/cpp/openScenarioLib/src/common/ContentMessage.h b/cpp/openScenarioLib/src/common/ContentMessage.h
index aa01408..6375f7c 100644
--- a/cpp/openScenarioLib/src/common/ContentMessage.h
+++ b/cpp/openScenarioLib/src/common/ContentMessage.h
@@ -27,7 +27,7 @@
 
 namespace NET_ASAM_OPENSCENARIO
 {
-    class ContentMessage
+    class OPENSCENARIOLIB_EXP ContentMessage
     {
 
     private:
@@ -42,7 +42,7 @@ namespace NET_ASAM_OPENSCENARIO
          * @param errorLevel the error level of the message
          */
 		OPENSCENARIOLIB_EXP ContentMessage(const std::string message = "", const ErrorLevel errorLevel = INFO);
-		OPENSCENARIOLIB_EXP virtual ~ContentMessage() = default;
+		OPENSCENARIOLIB_EXP virtual ~ContentMessage();
     	
         /**
          * The text of a message
diff --git a/cpp/openScenarioLib/src/common/FileContentMessage.cpp b/cpp/openScenarioLib/src/common/FileContentMessage.cpp
index b0c7c85..1cccfdd 100644
--- a/cpp/openScenarioLib/src/common/FileContentMessage.cpp
+++ b/cpp/openScenarioLib/src/common/FileContentMessage.cpp
@@ -20,7 +20,9 @@
 namespace NET_ASAM_OPENSCENARIO
 {
 	    FileContentMessage::FileContentMessage(const std::string message, const ErrorLevel errorLevel, const Textmarker textmarker) : ContentMessage(message, errorLevel), _textmarker(textmarker) {}
-	
+
+        FileContentMessage::~FileContentMessage() {}
+
 		Textmarker FileContentMessage::GetTextmarker() const
         {
             return _textmarker;
diff --git a/cpp/openScenarioLib/src/common/FileContentMessage.h b/cpp/openScenarioLib/src/common/FileContentMessage.h
index 360819a..a9c0ebc 100644
--- a/cpp/openScenarioLib/src/common/FileContentMessage.h
+++ b/cpp/openScenarioLib/src/common/FileContentMessage.h
@@ -31,7 +31,7 @@ namespace NET_ASAM_OPENSCENARIO
      * that enables the user to trace the message back to a file location.
      *
      */
-    class FileContentMessage: public ContentMessage
+    class OPENSCENARIOLIB_EXP FileContentMessage: public ContentMessage
     {
     private:
         Textmarker _textmarker;
@@ -45,7 +45,7 @@ namespace NET_ASAM_OPENSCENARIO
          */
 		OPENSCENARIOLIB_EXP FileContentMessage(const std::string message, const ErrorLevel errorLevel, const Textmarker textmarker);
 
-        OPENSCENARIOLIB_EXP ~FileContentMessage() = default;
+        OPENSCENARIOLIB_EXP ~FileContentMessage();
 
         /**
          * The text marker that enables the user to trace the message back to a file location
diff --git a/cpp/openScenarioLib/src/loader/FileResourceLocator.cpp b/cpp/openScenarioLib/src/loader/FileResourceLocator.cpp
index fe87462..7a9e760 100644
--- a/cpp/openScenarioLib/src/loader/FileResourceLocator.cpp
+++ b/cpp/openScenarioLib/src/loader/FileResourceLocator.cpp
@@ -27,7 +27,7 @@
 
 namespace NET_ASAM_OPENSCENARIO
 {
-    FileResourceLocator::~FileResourceLocator() = default;
+    FileResourceLocator::~FileResourceLocator() {}
 
     std::shared_ptr<std::ifstream> FileResourceLocator::GetInputStream(std::string& symbolicFilename)
     {
@@ -40,7 +40,7 @@ namespace NET_ASAM_OPENSCENARIO
             throw ResourceNotFoundException(msg);
         }
 
-        auto infile = std::make_shared<std::ifstream>(result, std::ios::binary);
+        auto infile = std::make_shared<std::ifstream>(result.c_str(), std::ios::binary);
 #elif defined (__linux__) || defined (__APPLE__)
     auto infile = std::make_shared<std::ifstream>(symbolicFilename, std::ios::binary);
 #else
diff --git a/cpp/openScenarioLib/src/loader/FileResourceLocator.h b/cpp/openScenarioLib/src/loader/FileResourceLocator.h
index 3a1c6ff..fd27835 100644
--- a/cpp/openScenarioLib/src/loader/FileResourceLocator.h
+++ b/cpp/openScenarioLib/src/loader/FileResourceLocator.h
@@ -26,7 +26,7 @@ namespace NET_ASAM_OPENSCENARIO
 	/**
 	* Implements the resource locator in a file system
 	*/
-	class FileResourceLocator: public IResourceLocator 
+	class OPENSCENARIOLIB_EXP FileResourceLocator: public IResourceLocator 
 	{
 		public:
 			OPENSCENARIOLIB_EXP virtual ~FileResourceLocator();
diff --git a/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioImportLoaderFactoryV1_0.h b/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioImportLoaderFactoryV1_0.h
index 6ecf9ba..6e4cda2 100644
--- a/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioImportLoaderFactoryV1_0.h
+++ b/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioImportLoaderFactoryV1_0.h
@@ -28,7 +28,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
         * A factory for creating catalog loaders
         */
-        class XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
         {
         private:
 
diff --git a/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioLoaderFactoryV1_0.h b/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioLoaderFactoryV1_0.h
index 1ecc90e..cdb03c8 100644
--- a/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioLoaderFactoryV1_0.h
+++ b/cpp/openScenarioLib/src/v1_0/loader/XmlScenarioLoaderFactoryV1_0.h
@@ -27,7 +27,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
          * Factory for a XML loader
          */
-        class XmlScenarioLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioLoaderFactory : public IScenarioLoaderFactory
         {
 
         private:
diff --git a/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioImportLoaderFactoryV1_1.h b/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioImportLoaderFactoryV1_1.h
index 08a38e5..267e36f 100644
--- a/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioImportLoaderFactoryV1_1.h
+++ b/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioImportLoaderFactoryV1_1.h
@@ -28,7 +28,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
         * A factory for creating catalog loaders
         */
-        class XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
         {
         private:
 
diff --git a/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioLoaderFactoryV1_1.h b/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioLoaderFactoryV1_1.h
index 31aa23c..5360bbd 100644
--- a/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioLoaderFactoryV1_1.h
+++ b/cpp/openScenarioLib/src/v1_1/loader/XmlScenarioLoaderFactoryV1_1.h
@@ -27,7 +27,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
          * Factory for a XML loader
          */
-        class XmlScenarioLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioLoaderFactory : public IScenarioLoaderFactory
         {
 
         private:
diff --git a/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioImportLoaderFactoryV1_2.h b/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioImportLoaderFactoryV1_2.h
index 372ba3f..2c610c2 100644
--- a/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioImportLoaderFactoryV1_2.h
+++ b/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioImportLoaderFactoryV1_2.h
@@ -28,7 +28,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
         * A factory for creating catalog loaders
         */
-        class XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioImportLoaderFactory : public IScenarioLoaderFactory
         {
         private:
 
diff --git a/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioLoaderFactoryV1_2.h b/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioLoaderFactoryV1_2.h
index d8a3ec8..6f20d73 100644
--- a/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioLoaderFactoryV1_2.h
+++ b/cpp/openScenarioLib/src/v1_2/loader/XmlScenarioLoaderFactoryV1_2.h
@@ -27,7 +27,7 @@ namespace NET_ASAM_OPENSCENARIO
         /**
          * Factory for a XML loader
          */
-        class XmlScenarioLoaderFactory : public IScenarioLoaderFactory
+        class OPENSCENARIOLIB_EXP XmlScenarioLoaderFactory : public IScenarioLoaderFactory
         {
 
         private:
diff --git a/cpp/thirdparty/antlr/antlr4-4.8-mingw.patch b/cpp/thirdparty/antlr/antlr4-4.8-mingw.patch
new file mode 100644
index 0000000..c6900d9
--- /dev/null
+++ b/cpp/thirdparty/antlr/antlr4-4.8-mingw.patch
@@ -0,0 +1,12 @@
+diff -Naur antlr4-4.8.orig/runtime/Cpp/runtime/src/atn/LexerATNSimulator.h antlr4-4.8/runtime/Cpp/runtime/src/atn/LexerATNSimulator.h
+--- antlr4-4.8.orig/runtime/Cpp/runtime/src/atn/LexerATNSimulator.h	2020-01-19 17:18:55.000000000 +0100
++++ antlr4-4.8/runtime/Cpp/runtime/src/atn/LexerATNSimulator.h	2022-11-04 15:47:49.240727000 +0100
+@@ -15,7 +15,7 @@
+   /// "dup" of ParserInterpreter
+   class ANTLR4CPP_PUBLIC LexerATNSimulator : public ATNSimulator {
+   protected:
+-    class SimState {
++    class ANTLR4CPP_PUBLIC SimState {
+     public:
+       virtual ~SimState();
+ 
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiClassInterface.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiClassInterface.tpl
index eaad473..ed22568 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiClassInterface.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiClassInterface.tpl
@@ -27,6 +27,16 @@
 #include "OscInterfaces<%=fileSuffix%>.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -76,4 +86,14 @@ namespace NET_ASAM_OPENSCENARIO
 
 <%-}-%>
     }
-}
\ No newline at end of file
+}
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiEnumerationHeader.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiEnumerationHeader.tpl
index 3ddcb13..c8ee180 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiEnumerationHeader.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ApiEnumerationHeader.tpl
@@ -26,6 +26,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -96,3 +106,13 @@ namespace NET_ASAM_OPENSCENARIO
 <%-}-%>
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ImplClass.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ImplClass.tpl
index e2ec21f..ad6a10e 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ImplClass.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ImplClass.tpl
@@ -34,6 +34,16 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -177,4 +187,14 @@ namespace NET_ASAM_OPENSCENARIO
     <%-}-%>
 
     }
-}
\ No newline at end of file
+}
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ScenarioCheckerImpl.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ScenarioCheckerImpl.tpl
index f0b003c..bc02ced 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ScenarioCheckerImpl.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_0/ScenarioCheckerImpl.tpl
@@ -37,7 +37,7 @@ namespace NET_ASAM_OPENSCENARIO
     namespace <%=versionNamespace%>
     {
 <%= helper.makeClassJavaDoc(oscVersion, "        ")%>
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
@@ -95,4 +95,4 @@ namespace NET_ASAM_OPENSCENARIO
     <%-}-%>
         };
     }
-}
\ No newline at end of file
+}
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiClassInterface.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiClassInterface.tpl
index e74da56..de9c3e6 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiClassInterface.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiClassInterface.tpl
@@ -27,6 +27,16 @@
 #include "OscInterfaces<%=fileSuffix%>.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -96,4 +106,14 @@ namespace NET_ASAM_OPENSCENARIO
 
 <%-}-%>
     }
-}
\ No newline at end of file
+}
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiEnumerationHeader.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiEnumerationHeader.tpl
index ae03ea8..5e553e8 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiEnumerationHeader.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ApiEnumerationHeader.tpl
@@ -26,6 +26,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -107,3 +117,13 @@ namespace NET_ASAM_OPENSCENARIO
 <%-}-%>
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ImplClass.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ImplClass.tpl
index d5edb9e..0f6c60a 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ImplClass.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ImplClass.tpl
@@ -34,6 +34,16 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -204,4 +214,14 @@ namespace NET_ASAM_OPENSCENARIO
  <%- if(!attributes.isEmpty()){-%>
 			virtual void Resolve<%=primitiveType.toClassName()%>Expression(std::string& attributeKey, <%=cTypeString%>& value) override;		
 <%-}-%>	
-<%-}-%>	
\ No newline at end of file
+<%-}-%>	
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ScenarioCheckerImpl.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ScenarioCheckerImpl.tpl
index f0b003c..bc02ced 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ScenarioCheckerImpl.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_1/ScenarioCheckerImpl.tpl
@@ -37,7 +37,7 @@ namespace NET_ASAM_OPENSCENARIO
     namespace <%=versionNamespace%>
     {
 <%= helper.makeClassJavaDoc(oscVersion, "        ")%>
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
@@ -95,4 +95,4 @@ namespace NET_ASAM_OPENSCENARIO
     <%-}-%>
         };
     }
-}
\ No newline at end of file
+}
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiClassInterface.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiClassInterface.tpl
index e74da56..de9c3e6 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiClassInterface.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiClassInterface.tpl
@@ -27,6 +27,16 @@
 #include "OscInterfaces<%=fileSuffix%>.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -96,4 +106,14 @@ namespace NET_ASAM_OPENSCENARIO
 
 <%-}-%>
     }
-}
\ No newline at end of file
+}
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiEnumerationHeader.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiEnumerationHeader.tpl
index ae03ea8..5e553e8 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiEnumerationHeader.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ApiEnumerationHeader.tpl
@@ -26,6 +26,16 @@
 #include "DateTime.h"
 #include "MemLeakDetection.h"
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -107,3 +117,13 @@ namespace NET_ASAM_OPENSCENARIO
 <%-}-%>
     }
 }
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ImplClass.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ImplClass.tpl
index 4f9b65a..2994c6f 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ImplClass.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ImplClass.tpl
@@ -34,6 +34,16 @@
 
 // helper.getTypeImportCpp(element,packageName).each{importedType->%>import =importedType%>
 
+#ifdef ABSOLUTE
+    #define ABSOLUTE_WAS_SET ABSOLUTE
+    #undef ABSOLUTE
+#endif
+
+#ifdef RELATIVE
+    #define RELATIVE_WAS_SET RELATIVE
+    #undef RELATIVE
+#endif
+
 namespace NET_ASAM_OPENSCENARIO
 {
     namespace <%=versionNamespace%>
@@ -203,4 +213,14 @@ namespace NET_ASAM_OPENSCENARIO
  <%- if(!attributes.isEmpty()){-%>
 			virtual void Resolve<%=primitiveType.toClassName()%>Expression(std::string& attributeKey, <%=cTypeString%>& value) override;		
 <%-}-%>	
-<%-}-%>	
\ No newline at end of file
+<%-}-%>	
+
+#ifdef ABSOLUTE_WAS_SET
+    #define ABSOLUTE ABSOLUTE_WAS_SET
+    #undef ABSOLUTE_WAS_SET
+#endif
+
+#ifdef RELATIVE_WAS_SET
+    #define RELATIVE RELATIVE_WAS_SET
+    #undef RELATIVE_WAS_SET
+#endif
diff --git a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ScenarioCheckerImpl.tpl b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ScenarioCheckerImpl.tpl
index f0b003c..bc02ced 100644
--- a/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ScenarioCheckerImpl.tpl
+++ b/generator/de.rac.openscenario.generator/src/main/resources/templates/cpp/v1_2/ScenarioCheckerImpl.tpl
@@ -37,7 +37,7 @@ namespace NET_ASAM_OPENSCENARIO
     namespace <%=versionNamespace%>
     {
 <%= helper.makeClassJavaDoc(oscVersion, "        ")%>
-        class ScenarioCheckerImpl: public IScenarioChecker
+        class OPENSCENARIOLIB_EXP ScenarioCheckerImpl: public IScenarioChecker
         {
         private:
             enum ContextMode { MODE_TREE, MODE_FILE };
@@ -95,4 +95,4 @@ namespace NET_ASAM_OPENSCENARIO
     <%-}-%>
         };
     }
-}
\ No newline at end of file
+}
